function varargout = savemodel(varargin)
% SAVEMODEL M-file for savemodel.fig
%      SAVEMODEL, by itself, creates a new SAVEMODEL or raises the existing
%      singleton*.
%
%      H = SAVEMODEL returns the handle to a new SAVEMODEL or the handle to
%      the existing singleton*.
%
%      SAVEMODEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAVEMODEL.M with the given input arguments.
%
%      SAVEMODEL('Property','Value',...) creates a new SAVEMODEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before savemodel_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to savemodel_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help savemodel

% Last Modified by GUIDE v2.5 01-Feb-2004 11:25:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @savemodel_OpeningFcn, ...
                   'gui_OutputFcn',  @savemodel_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before savemodel is made visible.
function savemodel_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for savemodel
handles.output = hObject;

% Position GUI
movegui(handles.fSaveModel,'center');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes savemodel wait for user response (see UIRESUME)
uiwait(handles.fSaveModel);

% --- Outputs from this function are returned to the command line.
function varargout = savemodel_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.ModelSelected;
varargout{2} = handles.PreprocessedSelected;

delete(handles.fSaveModel);  

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
function cbModel_Callback(hObject, eventdata, handles)

if    ~get(hObject,'Value') & ~get(handles.cbPreprocess,'Value')
  set(handles.pbOK,'Enable','off');
elseif get(hObject,'Value') | get(handles.cbPreprocess,'Value')
  set(handles.pbOK,'Enable','on');
end

%--------------------------------------------------------------------------
function cbPreprocess_Callback(hObject, eventdata, handles)

if    ~get(hObject,'Value') & ~get(handles.cbModel,'Value')
  set(handles.pbOK,'Enable','off');
elseif get(hObject,'Value') | get(handles.cbModel,'Value')
  set(handles.pbOK,'Enable','on');
end

%--------------------------------------------------------------------------
function pbOK_Callback(hObject, eventdata, handles)

handles.ModelSelected        = get(handles.cbModel,'Value');
handles.PreprocessedSelected = get(handles.cbPreprocess,'Value');
guidata(hObject,handles);

uiresume(handles.fSaveModel);

%--------------------------------------------------------------------------
function pbCancel_Callback(hObject, eventdata, handles)

handles.ModelSelected        = 0;
handles.PreprocessedSelected = 0;
guidata(hObject,handles);

uiresume(handles.fSaveModel);

%--------------------------------------------------------------------------
function fSaveModel_KeyPressFcn(hObject, eventdata, handles)

CurChar = get(hObject,'CurrentCharacter');
CurVal  = double(CurChar);
if isempty(CurVal)
  return
end
if isequal(CurVal,27)
  pbCancel_Callback(hObject, eventdata, handles);
elseif isequal(CurVal,13)
  pbOK_Callback(hObject, eventdata, handles);
end